generic Size: INTEGER;		
package IntMatrices is
  type IntMatrix is array (1..Size,1..Size) OF INTEGER;
  function ParMult(a,b: in IntMatrix) return IntMatrix;
end;
package body IntMatrices is
  function ParMult(a,b: in IntMatrix) return IntMatrix is
    c:IntMatrix;
    task type Mult is
      entry DoRow (i: in INTEGER); entry EndRow ;
    end;
    task body Mult is
      iloc: INTEGER;
    begin
      accept DoRow (i: in INTEGER) do  iloc := i; end;
      for j in 1..Size loop
        c(iloc, j) := 0;
        for k in 1..Size loop
          c(iloc, j) := c(iloc,j) + a(iloc,k) * b(k,j);
        end loop;
      end loop;
      accept EndRow;
    end Mult;
  begin -- ParMult
    declare m: array (1..Size) of Mult;
    begin
      for i in 1..Size loop
        m(i).DoRow(i);
      end loop;
      for i in 1..Size loop
        m(i).EndRow;
      end loop;
    end;
    return c;
  end ParMult;
end IntMatrices;
with IntMatrices;  with Text_IO; use Text_IO;
procedure Zkus is
    package Muj is new IntMatrices(2);
    package Muj_IO is new Integer_IO(integer);
    use Muj, Muj_IO;
    A: IntMatrix := ((5,5),(5,5)); B: IntMatrix := ((3,3),(3,3));
    C: IntMatrix;
begin
        C:=ParMult(A,B);
        put(c(1,1)); put(c(1,2));put(c(2,1));put(c(2,2));
end Zkus;
